
\ Frank Jan Sorensen Alias:Frank Patxi (fjs@lab.jt.dk) for the fireroutine.

\ Program Burn

0 TO WARNING

  20  CONSTANT  RootRand     ( Max/Min decrease of the root of the flames )
  10  CONSTANT  Decay        ( How far should the flames go up on the screen? )
 100  CONSTANT  MinY         ( Startingline of the flame routine.
                               (should be adjusted along with MinY above)
   1  CONSTANT  Smooth       ( How descrete can the flames be?)
  50  CONSTANT  MinFire      ( limit between the "starting to burn" and
                               the "is burning" routines )
  90  CONSTANT  XStart       ( Startingpos on the screen )
 210  CONSTANT  XEnd         ( Guess! )
 XEnd XStart
   -  CONSTANT  Width        ( Well- )
 110  CONSTANT  MaxColor     ( Constant for the MakePal procedure )
  90  CONSTANT  FireIncrease ( 3 = Wood, 90 = Gazolin )

  0  VALUE  Pal                         \ Pal -  


: WRITEPAL      ( Pal -- )

[
        HEX
        033 C, 0DB C,           \ xor   bx, bx
        0B9 C, 0100 ,           \ mov   cx, 256
        00E C,                  \ push  cs
        007 C,                  \ pop   es
        0BA C, 03DA ,           \ mov   dx, 03DAh
 ( WP:) 0EC C,                  \ in    al, dx          \ Wait for rescan
        0A8 C, 08 C,            \ test  al, 8
        074 C, 0FB C,           \ jz    WP
        08B C, 056 C, 0 C,      \ mov   dx, [bp]        \ Pal - es:dx
        0B8 C, 1012 ,           \ mov   ax, 1012h
        0CD C, 010 C,           \ int   10h
        04D C,                  \ dec   bp
        04D C,                  \ dec   bp
        DECIMAL
]
;


: Put           ( x y c -- )    \ Written by Matt Sottile
[
        HEX
        08B C, 046 C, 0FE C,    \ mov   ax, [bp-2]      ( y )
        08B C, 0D8 C,           \ mov   bx, ax
        0C1 C, 0E0 C, 08 C,     \ shl   ax, 8
        0C1 C, 0E3 C, 06 C,     \ shl   bx, 6
        003 C, 0D8 C,           \ add   bx, ax
        003 C, 05E C, 0FC C,    \ add   bx, [bp-4]      ( x )
        0B8 C, 0A000 ,          \ mov   ax, 0a000h
        08E C, 0C0 C,           \ mov   es, ax
        08A C, 046 C, 0 C,      \ mov   al, [bp]        ( c )
        026 C, 088 C, 07 C,     \ mov   es:[bx], al
        083 C, 0ED C, 06 C,     \ sub   bp, 6
        DECIMAL
]
;


: Get           ( x y -- c )
[
        HEX
        08B C, 046 C, 0 C,      \ mov   ax, [bp]
        08B C, 0D8 C,           \ mov   bx, ax
        0C1 C, 0E0 C, 08 C,     \ shl   ax, 8
        0C1 C, 0E3 C, 06 C,     \ shl   bx, 6
        003 C, 0D8 C,           \ add   bx, ax
        003 C, 05E C, 0FE C,    \ add   bx, [bp-2]
        0B8 C, 0A000 ,          \ mov   ax, 0a000h
        08E C, 0C0 C,           \ mov   es, ax
        026 C, 08A C, 07 C,     \ mov   al, es:[bx]
        032 C, 0E4 C,           \ xor   ah, ah
        083 C, 0ED C, 02 C,     \ sub   bp, 2
        089 C, 046 C, 0 C,      \ mov   [bp], ax
        DECIMAL
]
;


CREATE SinTable

00000 , 0175 , 0349 , 0523 , 0698 , 0872 , 1045 , 1219 , 1392 ,
 1564 , 1736 , 1908 , 2079 , 2250 , 2419 , 2588 , 2756 , 2924 ,
 3090 , 3256 , 3420 , 3584 , 3746 , 3907 , 4067 , 4226 , 4384 ,
 4540 , 4695 , 4848 , 5000 , 5150 , 5299 , 5446 , 5592 , 5736 ,
 5878 , 6018 , 6157 , 6293 , 6428 , 6561 , 6691 , 6820 , 6947 ,
 7071 , 7193 , 7314 , 7431 , 7547 , 7660 , 7771 , 7880 , 7986 ,
 8090 , 8192 , 8290 , 8387 , 8480 , 8572 , 8660 , 8746 , 8829 ,
 8910 , 8988 , 9063 , 9135 , 9205 , 9272 , 9336 , 9397 , 9456 ,
 9511 , 9563 , 9613 , 9659 , 9703 , 9744 , 9781 , 9816 , 9848 ,
 9877 , 9903 , 9925 , 9945 , 9962 , 9976 , 9986 , 9994 , 9998 ,
10000 ,

: SIN180        ( n -- sin n, 0<=n<=180 )
        DUP 90 >  IF 180 SWAP -  THEN 2* SinTable + @
;
: SIN           ( n -- sin n )
        360 MOD DUP 0<  IF 360 +  THEN
        DUP 180 >  IF 180 - SIN180 NEGATE  ELSE SIN180  THEN
;


: HSI2RGB  ( addr i s h -- )  \ Convert (Hue, Saturation, Intensity) -> (RGB)

        2DUP  [ 31415 2 3 */ ] LITERAL  -  57      \ 1 ࠤ = 57 ࠤᮢ
        10000 */ SIN  SWAP 10000 */ 10000 +   >R   \ ᨭ  ⠡஢

        2DUP 57 10000 */ SIN  SWAP 10000 */ 10000 +  >R

        [ 31415 2 3 */ ] LITERAL  +  57
        10000 */ SIN  SWAP 10000 */ 10000 +  >R

        [ 64 2 / ] LITERAL  10000 */

        2DUP  R> 10000 */ SWAP 2+ C!
        2DUP  R> 10000 */ SWAP 1+ C!
        R> 10000 */ SWAP C!
;


: MAKEPAL

        Pal [ 256 ( Color) 3 ( RGB) * ] LITERAL CS>ES ERASE \  

        MaxColor 1+ 1
        DO
                I 3 * Pal +                   \ Pal[i]     - 1- ࠬ
                I 10000 MaxColor */           \ I/MaxColor - 2- ࠬ
                DUP                           \            - 3- ࠬ
                46000 OVER 3 2 */ -           \ 4.6-1.5*I/MaxColor - 4-
                HSI2RGB
        LOOP

        256 MaxColor
        DO
                I 1- 3 * Pal +  DUP 3+  3  CMOVE   \ ES 㦥 ⠭  ERASE

                I 3 * Pal +  DUP C@  63 < IF  DUP 1+!  THEN
                             DUP C@  63 < IF  DUP 1+!  THEN
                1+  DUP C@  53 <  I 2 MOD 0=  AND IF  DUP 1+!  THEN
                1+  DUP C@  63 <  I 2 MOD 0=  AND IF 1+!  ELSE DROP  THEN
        LOOP

        Pal WRITEPAL
;


: RAND          ( n -- n )      \ Return a random number between -R And R
        DUP 2* 1+ RANDOM SWAP -
;


  0  VALUE  FlameArray                      \ FlameArray -  ᨢ Flame
  1  VALUE  MoreFire


: BURN

[
        HEX
        033 C, 0C0 C,           \ xor   ax, ax
        09C C,                  \ pushf
        05B C,                  \ pop   bx
        080 C, 0E7 C, 0F C,     \ and   bh, 0fh
        053 C,                  \ push  bx
        09D C,                  \ popf
        09C C,                  \ pushf
        059 C,                  \ pop   cx
        080 C, 0E5 C, 0F0 C,    \ and   ch, 0f0h
        080 C, 0FD C, 0F0 C,    \ cmp   ch, 0f0h
        075 C, 01B C,           \ jnz   VGA

( ERR:) 0BA C, 011E ,           \ mov   dx, STR
        0B4 C, 09 C,            \ mov   ah, 9
        0CD C, 021 C,           \ int   21h             \ Need 286 and VGA
        0C3 C,                  \ ret
( STR:) 654E , 6465 , 3220 , 3638 , 6120 , 646E , 5620 , 4147 , 0A0D , 24 C,

( VGA:) 0B8 C, 01A00 ,          \ mov   ax, 01a00h
        0CD C, 010 C,           \ int   10h
        03C C, 01A C,           \ cmp   al, 01ah        \ VGA ?
        075 C, 0DC C,           \ jnz   ERR
        080 C, 0FB C, 07 C,     \ cmp   bl, 7           \ -1, 0-6  < 7
        07C C, 0D7 C,           \ jl    ERR
        DECIMAL
]
        PAD 2+ ALIGNED                      \ ।   Pal  PAD
        TO Pal                              \  - "뤥" ᪨

        Pal [ 256 3 * 2+ ] LITERAL +        \ ।   FlameArray
        ALIGNED  TO FlameArray              \  - "뤥" ᪨

        RANDOMIZE

[
        HEX
        0B8 C, 0F00 ,           \ mov   ax, 0F00h       \ 騩 ० ࠭
        0CD C, 010 C,           \ int   10h
        050 C,                  \ push  ax
        0B8 C, 013 ,            \ mov   ax, 0013h       \ 320*200*256 VGA/MCGA
        0CD C, 010 C,           \ int   10h
        DECIMAL
]
        MAKEPAL
(
        \ Use this if want to view the palette
        256 0 DO
          21 0 DO
            J I J Put
          LOOP
        LOOP
        KEY DROP
( )
        \  Initialize FlameArray
        FlameArray XStart +  [ Width 1+ ] LITERAL  CS>ES ERASE

        \ Clear screen
        0000  [ 320 200 * ] LITERAL  [ HEX A000 DECIMAL ] LITERAL ES!  ERASE

\        BEGIN KEY?  WHILE KEY DROP  REPEAT      \ Empty Keyboard buffer

        BEGIN

              \ Put the values from FlameArray on the bottom line of the screen

                [ XEnd 1+ ] LITERAL  [ XStart ] LITERAL
                DO
                        I  199  FlameArray I + C@   Put
                LOOP


              \ This loop makes the actual flames

                [ XEnd 1+ ] LITERAL  [ XStart ] LITERAL
                DO
                        200  [ MinY ] LITERAL
                        DO
                                J I Get
                                DUP DUP
                                0=
                                SWAP [ Decay ] LITERAL  <  OR
                                J [ XStart ] LITERAL  > NOT  OR
                                J [ XEnd ] LITERAL  < NOT  OR
                                IF
                                        J  I 1-  0  Put
                                        DROP
                                ELSE
                                        J  3 RANDOM 1-  -
                                        I 1-
                                        ROT  [ Decay ] LITERAL  RANDOM  -
                                        Put
                                THEN
                        LOOP
                LOOP

              \ Match?

                150 RANDOM 0=
                IF
                        [ XEnd XStart - 5 - ] LITERAL
                        RANDOM  [ XStart ] LITERAL  +  FlameArray +
                        5 255 CS>ES FILL
                THEN

              \ This loop controls the "root" of the flames
              \ ie. the values in FlameArray.

                [ XEnd 1+ ] LITERAL  [ XStart ] LITERAL
                DO
                        FlameArray I + C@  DUP
                        [ MinFire ] LITERAL  <  \ Increase by the "burnability"
                        IF
                                DUP 10 >
                                IF                          \ Starting to burn:
                                        [ FireIncrease ] LITERAL  RANDOM
                                        +
                                THEN
                        ELSE            \ Otherwise randomize and increase by
                                        \  intensity (is burning)

                                [ RootRand ] LITERAL  RAND
                                 [ MoreFire ] LITERAL  + +
                        THEN
                        DUP 255 > IF DROP 255 THEN      \ X Too large ?
                        FlameArray I + C!
                LOOP

              \ Pour a little water on both sides of
              \ the fire to make it look nice on the sides

                [ Width 8 / 1+ ] LITERAL  1
                DO
                        10000 RANDOM
                        DUP 10000 */  [ Width 8 / ] LITERAL  10000 */
                        0  OVER FlameArray [ XStart ] LITERAL  + +  C!
                        0  FlameArray [ XEnd ] LITERAL + ROT -  C!
                LOOP

              \ Smoothen the values of FrameArray to avoid "descrete" flames

                [ XEnd Smooth - 1+ ] LITERAL  [ XStart Smooth + ] LITERAL
                DO
                        0
                        [ Smooth 1+ ] LITERAL  [ Smooth NEGATE ] LITERAL
                        DO
                                J I + FLameArray + C@  +
                        LOOP
                        [ Smooth 2* 1+ ] LITERAL  /
                        FlameArray I +  C!
                LOOP

                KEY?  IF KEY 27 =  ELSE FALSE  THEN
        UNTIL

[
        HEX
        058 C,                  \ pop   ax
        032 C, 0E4 C,           \ xor   ah, ah
        0CD C, 010 C,           \ int   10h
        DECIMAL
]

;

.( Done)

